﻿$(document).on('ajaxError', function (e, xhr, options) {
    try {
        console.log("【AjaxHttpError】" + options.url + "; 【Status】" + xhr.status + "; 【Message】" + e._args[2]);
    } catch (ex) {

    }
})

// 默认使用JSON
$.ajaxSettings.dataType = "json";

// 图片转Base64
function getBase64FromDataUrl(data) {
    return data.split(',')[1];
}

function getBase64Image(img) {
    var canvas = document.createElement("canvas");
    canvas.width = img.width;
    canvas.height = img.height;

    var ctx = canvas.getContext("2d");
    ctx.drawImage(img, 0, 0, img.width, img.height);

    var dataURL = canvas.toDataURL("image/jpeg");
    if (dataURL.length < 20) {
        console.log("base64 error");
        return "";
    }
    return dataURL.replace("data:image/jpeg;base64,", "");
}

// 从文件得到Base64
function getBase64ImageFromFile(fileElement, onload, onprogress) {
    var fr = new FileReader();
    var files = fileElement.files;
    if (!files || files.length <= 0) {
        return;
    }

    if (onprogress) {
        fr.onprogress = function (e) {
            onprogress(e)
        };
    };

    fr.onloadend = function () {
        var fileName = files[0].name;
        var data = getBase64FromDataUrl(this.result);
        if (onload) {
            onload(fileName, data);
        }
    };
    fr.readAsDataURL(files[0]);
}