﻿var McActionSheet = {
    show: function (items, itemClick) {
        var html = '<div class="action-sheet">';
        for (var i = 0; i < items.length; i++) {
            var item = items[i];
            html += '<div class="sheet-item" value="' + i + '">';
            if (item.indexOf("【管理】") >= 0) {
                html += '<div class="sheet-item-text" style="color: #ff9600">' + item + '</div>';
            } else {
                html += '<div class="sheet-item-text">' + item + '</div>';
            }
            html += "</div>";
        }
        html += '<div class="sheet-item" value="-1"><div class="sheet-item-text">取消</div></div></div>';
        html += '<div class="action-sheet-mask"></div>';
        var $sheet = $(html);
        $("body").append($sheet);
        $sheet.show().addClass("show").on("tap", ".sheet-item", function (e) {
            var value = parseInt($(this).attr("value"));
            if (value < 0) {
                McActionSheet.remove();
            }
            if (itemClick) {
                var valueText = items[value];
                itemClick(value, valueText);
            }
            e.preventDefault();
            return false;
        });
    },
    remove: function () {
        $(".action-sheet,.action-sheet-mask").remove();
    }
};

var McImageUploader = {
    thumbImage: function (origImg, fileName, data, maxWidth, maxHeight) {
        var ispng = fileName.indexOf("png") >= 0;
        var isjpg = fileName.indexOf("jpg") >= 0 || fileName.indexOf("jpeg") >= 0;

        var thumbData = "";

        // 非jpeg直接压缩上传
        if (!isjpg) {
            var origWidth = origImg.naturalWidth;
            var origHeight = origImg.naturalHeight;

            var scaleWidth = origWidth / maxWidth;
            var scaleHeight = origHeight / maxHeight;
            var scale = Math.max(1, scaleWidth, scaleHeight);
            if (scale > 1) {
                var thumbWidth = origWidth / scale;
                var thumbHeight = origHeight / scale;

                var cvs = document.createElement("canvas");
                cvs.width = thumbWidth;
                cvs.height = thumbHeight;
                var ctx = cvs.getContext("2d");
                ctx.drawImage(origImg, 0, 0, thumbWidth, thumbHeight);
                var dataUrl = cvs.toDataURL();
                ctx = null;
                cvs = null;
                thumbData = dataUrl.split(',')[1];
                return thumbData;
            } else {
                // 小图则直接返回原图
                return data;
            }
        }

        var jpegFile = {};
        try {
            jpegFile = new JpegMeta.JpegFile(atob(data), file);
        } catch (ex) {
        }
        // 判定图片方向
        /*
            1: "Normal",
            2: "Reverse?",
            3: "Upside-down",
            4: "Upside-down Reverse",
            5: "90 degree CW",
            6: "90 degree CW reverse",
            7: "90 degree CCW",
            8: "90 degree CCW reverse"
        */
        var orientation = ((jpegFile.tiff || {}).Orientation || {}).value || 1;

        function e(a, b, c) {
            var d, e = document.createElement("canvas"), f = e.getContext("2d"), g = 0, h = c, i = c;
            for (e.width = 1,
            e.height = c,
            f.drawImage(a, 1 - Math.ceil(Math.random() * b), 0),
            d = f.getImageData(0, 0, 1, c).data; i > g;) {
                var j = d[4 * (i - 1) + 3];
                0 === j ? h = i : g = i,
                i = h + g >> 1
            }
            return console.log("ratio is ", i / c),
            i / c
        }
        function f(a, b, c, d) {
            d = d || {},
            "square" === d.type ? (a.width = d.s,
            a.height = d.s) : d.orient >= 5 && d.orient <= 8 ? (a.width = c,
            a.height = b) : (a.width = b,
            a.height = c)
        }

        function d(a) {
            var b = a.naturalWidth
              , c = a.naturalHeight
              , d = !1;
            if (b * c > 1048576) {
                var e = document.createElement("canvas")
                  , f = e.getContext("2d");
                e.width = e.height = 1,
                f.drawImage(a, 1 - b, 0),
                d = 0 === f.getImageData(0, 0, 1, 1).data[3],
                console.log("is ios sub sample: ", f.getImageData(0, 0, 1, 1).data, d),
                e = f = null
            }
            return d
        }

        // 根据图片方向设定canvas的渲染坐标和方向
        function c(a, b, c, d) {
            var e = a.getContext("2d");
            switch (d) {
                case 2:
                    e.translate(b, 0),
                    e.scale(-1, 1);
                    break;
                case 3:
                    e.translate(b, c),
                    e.rotate(Math.PI);
                    break;
                case 4:
                    e.translate(0, c),
                    e.scale(1, -1);
                    break;
                case 5:
                    e.rotate(.5 * Math.PI),
                    e.scale(1, -1);
                    break;
                case 6:
                    e.rotate(.5 * Math.PI),
                    e.translate(0, -c);
                    break;
                case 7:
                    e.rotate(.5 * Math.PI),
                    e.translate(b, -c),
                    e.scale(-1, 1);
                    break;
                case 8:
                    e.rotate(-.5 * Math.PI),
                    e.translate(-b, 0)
            }
        }

        function n() {
            return !0
        }


        try {
            // 微社区旋转压缩图片的代码
            thumbData = (function (a, b) {
                var g, h, i, j = maxWidth, k = maxHeight, l = 0.92, m = a.naturalWidth, o = a.naturalHeight, p = b.type, q = b.side, r = 0, s = 0;
                n() && d(a) && (m /= 2,
                o /= 2),
                "square" === p ? m > q && m > o ? (g = m * q / o,
                h = q,
                r = (m - o) / 2,
                i = q) : o > q && o > m ? (g = q,
                h = o * q / m,
                s = (o - m) / 2,
                i = q) : (g = m,
                h = o,
                i = Math.min(g, h)) : m > j && m / o >= j / k ? (g = j,
                h = o * j / m) : o > k && o / m >= k / j ? (g = m * k / o,
                h = k) : (g = m,
                h = o);
                var t, u = document.createElement("canvas"), v = u.getContext("2d");
                if (f(u, g, h, $.extend({
                    s: i
                }, b)),
                c(u, g, h, b.orient),
                n()) {
                    var w, x, y, z, A, B, C, D, E = document.createElement("canvas"), F = E.getContext("2d"), G = 1024, H = e(a, m, o);
                    for (E.width = E.height = G,
                    w = 0; o > w;) {
                        for (z = w + G > o ? o - w : G,
                        x = 0; m > x;)
                            y = x + G > m ? m - x : G,
                            F.clearRect(0, 0, G, G),
                            F.drawImage(a, -x - r, -w - s),
                            A = Math.floor(x * g / m),
                            C = Math.ceil(y * g / m),
                            B = Math.floor(w * h / o / H),
                            D = Math.ceil(z * h / o / H),
                            v.drawImage(E, 0, 0, y, z, A, B, C, D),
                            x += G;
                        w += G
                    }
                    E = F = null
                } else
                    v.drawImage(a, 0, 0, m, o, 0, 0, g, h);
                t = u.toDataURL("image/jpeg", l);
                //if (n())
                //    t = u.toDataURL("image/png", l);
                //else {
                //    var I = v.getImageData(0, 0, u.width, u.height)
                //      , J = new JPEGEncoder(100 * l);
                //    t = J.encode(I),
                //    J = null
                //}
                return u = v = null,
                t
            })(origImg, { orient: orientation });
            thumbData = thumbData.split(',')[1];
        } catch (ex) {
            // 如果失败，则直接压缩
            var origWidth = origImg.naturalWidth;
            var origHeight = origImg.naturalHeight;

            var scaleWidth = origWidth / maxWidth;
            var scaleHeight = origHeight / maxHeight;
            var scale = Math.max(1, scaleWidth, scaleHeight);
            var thumbWidth = origWidth / scale;
            var thumbHeight = origHeight / scale;

            var cvs = document.createElement("canvas");
            cvs.width = thumbWidth;
            cvs.height = thumbHeight;
            var ctx = cvs.getContext("2d");
            ctx.drawImage(origImg, 0, 0, thumbWidth, thumbHeight);
            var dataUrl = cvs.toDataURL();
            ctx = null;
            cvs = null;
            thumbData = dataUrl.split(',')[1];
        }
        return thumbData;
    },
    uploadFile: function (opt) {
        // 异步Promise化
        var totalDeferred = $.Deferred();

        var options = $.extend({
            thumb: false,
            maxWidth: 640,
            //maxHeight: 960,
            previewImageElement: null,
            picElement: null,
        }, opt);

        //var fr = new FileReader();

        var fileName = opt.ImgName;
        var Data = opt.ImgData;
        //alert(fileName);
        //alert(Data);
        if (!options.previewImageElement) {
            return;
        }
        var ispng = fileName.indexOf("png") >= 0;
        var isjpg = fileName.indexOf("jpg") >= 0 || fileName.indexOf("jpeg") >= 0;

        options.previewImageElement.src = (isjpg ? "data:image/jpeg;base64," : "data:image/png;base64,") + Data;
        options.previewImageElement.onload = function () {

            var loadingDeferred = $.Deferred();
            options.picElement.find(".up-progress .pos").animate({ width: "28.5px" }, 2500, "ease-out", function () {
                // 动画完成
                loadingDeferred.resolve();
            });
            var uploadPromise = null;
            var animatePromise = loadingDeferred.promise();

            //alert(JSON.stringify(animatePromise));

            // 需要压缩
            if (options.thumb) {
                //var thumbData = McImageUploader.thumbImage(options.previewImageElement, fileName, Data, options.maxWidth, options.maxHeight);
                uploadPromise = MCAPI.uploadImage({
                    FileName: fileName,
                    Data: Data
                });

            } else {
                // 如果不压缩，直接上传原图
                uploadPromise = MCAPI.uploadImage({
                    FileName: fileName,
                    Data: Data
                });
            }

            // 同时等待动画和ajax完成
            $.when(animatePromise, uploadPromise).done(function (_, uploadRet) {
                // 上传完成，去掉onload事件
                options.previewImageElement.onload = null;
                // 如果上传成功，以图片网址通知调用方
                if (uploadRet && uploadRet.length > 0 && uploadRet[0].Images && uploadRet[0].Images.length > 0) {
                    totalDeferred.resolve(uploadRet[0].Images[0]);
                } else {
                    totalDeferred.resolve("");
                }
                // 播放剩下的进度条动画
                options.picElement.find(".up-progress .pos").animate({ width: "38px" }, 1000, "ease-out", function () {
                    options.picElement.addClass("up-over");
                    $("#file").val("");
                });
            }).fail(function () {
                totalDeferred.resolve("");
            });
        };
        //fr.readAsDataURL(file);
        return totalDeferred.promise();
    },
    uploadFileNew: function (opt) {

        var options = $.extend({
            thumb: false,
            maxWidth: 640,
            //maxHeight: 960,
            previewImageElement: null,
            picElement: null,
        }, opt);

        //var fr = new FileReader();

        var fileName = opt.ImgName;
        var Data = opt.ImgData;
        //alert(fileName);
        //alert(Data);
        if (!options.previewImageElement) {
            return;
        }

        options.previewImageElement.onload = function () {
            MCAPI.uploadImage({
                FileName: fileName,
                Data: Data,
            }, function (uploadRet) {
                if (uploadRet) {
                    uploadRet.Images = replaceImg(uploadRet.Images);
                    opt.picElement.src = uploadRet.Images;
                } else {
                    return;
                }
            });
        };
        //fr.readAsDataURL(file);
        return;
    }

};

McLocationSelector = {
    show: function (locations, callback) {
        var $div = $("<div><ul id='location'></ul></div>");
        var $location = $div.find("#location");

        var winH = $(window).height();

        var list = "";
        $.each(locations, function (index, element) {
            list += "<li lng='" + element.lng + "' lat='" + element.lat + "'><h3>" + element.title + "</h3><span>" + element.detail + "</span></li>";
        });
        $location
            .css('min-height', winH + 'px')
            .append($(list)).on("click", "li", function (e) {
                var $this = $(this);
                if (callback) {
                    callback({
                        lng: $this.attr("lng"),
                        lat: $this.attr("lat"),
                        title: $this.find("h3").text(),
                        detail: $this.find("span").text()
                    });
                    $("#location").parent().remove();
                }
            });

        $div.appendTo($("body"));
    }
};

McTopic = {
    addManageBtn: function (callback) {
        var html = '<div class="manage"><img src="images/manage.png"></div>';
        var $btn = $(html);
        $btn.click(callback);
        $("body").append($btn);
    },
    addAdminBtn: function (callback) {
        var html = '<div class="manage_admin"><img src="images/manage.png"></div>';
        var $btn = $(html);
        $btn.click(callback);
        $("body").append($btn);
    },
};

(function ($) {
    $.cookie = function (name, value, options) {
        if (typeof value != 'undefined') { // name and value given, set cookie
            options = options || {};
            if (value === null) {
                value = '';
                options.expires = -1;
            }
            var expires = '';
            if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
                var date;
                if (typeof options.expires == 'number') {
                    date = new Date();
                    date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
                } else {
                    date = options.expires;
                }
                expires = '; expires=' + date.toUTCString(); // use expires attribute, max-age is not supported by IE
            }
            var path = options.path ? '; path=' + options.path : '';
            var domain = options.domain ? '; domain=' + options.domain : '';
            var secure = options.secure ? '; secure' : '';
            document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
        } else { // only name given, get cookie
            var cookieValue = null;
            if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = $.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }
    }
})(Zepto);

McDocumentTitle = {
    set: function (title, prefix) {
        var origTitle = document.title || "";
        if (!origTitle) {
            document.title = title;
            return;
        }

        if (prefix) {
            document.title = title + " " + document.title;
        } else {
            document.title = document.title + " " + title;
        }
    }
};